/*
 * Project name:
     PID BAR Example 1
 * Author:
     Stevan Tosic
 * Date:
     11.05.2012.
 * Revision History:
       - initial release;
 * Description:
     This is a simple BAR progress library
 * Test configuration:
     MCU:             P18F8520
     dev.board:       bigpic5
     Oscillator:      HS, 8.0 MHz
     Ext. Modules:    -
     SW:              mikroC PRO for PIC 5.0.1.
 * NOTES:
     - Progress bar on GLCD
*/

#include "bar.h"

void bar_init(BAR *ptrbar, int yold, int y, int mx, int my, int c, int d)
{
   ptrbar->yold=yold;
   ptrbar->midx=mx;
   ptrbar->midy=my;
   ptrbar->color=c;
   ptrbar->delta=d;
   ptrbar->y=y;

   //setfillstyle(SOLID_FILL, 15);
   Glcd_Box(mx-d, my, mx+d,my, WHITE);
   bar_plot1(ptrbar);
}

void bar_set(BAR *ptrbar, int y)
{
   ptrbar->yold=ptrbar->y;
   ptrbar->y=y;
}

void bar_plot1(BAR *ptrbar)
{
       int yold, y, midx, midy,d, col, c1, c2, y1, y2, y3, y4, ind;
       
       //ptrbar->yold=ptrbar->y;
       //ptrbar->y=y;

       yold=ptrbar->yold;
       y=ptrbar->y;
       midx=ptrbar->midx;
       midy=ptrbar->midy;
       col=ptrbar->color;
       d=ptrbar->delta;
       if(yold>0 && y>0)
       {
          if(y>yold){
              y1=midy-y; y2=midy-yold-1;
              c1=col; ind=1;
          }
          else if(y<yold){
              y1=midy-yold; y2=midy-y-1;
              c1=BLACK; ind=1;
          }
          else{ ind=0; }
       }
       else if(yold<0 && y<0)
       {
          if(y>yold){
              y1=midy-y+1; y2=midy-yold;
              c1=BLACK; ind=1;
           }
          else if(y<yold){
              y1=midy-yold+1; y2=midy-y;
              c1=col; ind=1;
          }
          else{ ind=0; }
       }
       else if(yold<0 && y>0)
       {
           y1=midy+1; y2=midy-yold; c1=BLACK;
           y3=midy-y; y4=midy-1; c2=col;
           ind=2;
      }
       else if(yold>0 && y<0)
       {
           y1=midy-yold; y2= midy-1; c1=BLACK;
           y3=midy+1; y4=midy-y; c2=col;
           ind=2;
       }
       else if(yold==0){
           if(y>0){
               y1=midy-y; y2=midy-1;
               c1=col; ind=1;
           }
           else if(y<0){
              y1=midy+1; y2=midy-y;
              c1=col; ind=1;
           }
           else{ ind=0; }
       }
       else if(y==0){
           if(yold>0){
              y1=midy-yold; y2=midy-1;
              c1=BLACK; ind=1;
           }
           else if(yold<0){
               y1=midy+1; y2=midy-yold;
               c1=BLACK; ind=1;
           }
           else{ ind=0; }
       }
       else{ ind=0; }

       switch(ind){
          case 0: break;
          case 1:
             //setfillstyle(SOLID_FILL, c1);
             Glcd_Box(midx-d, y1, midx+d, y2, c1);
             break;
          case 2:
            //setfillstyle(SOLID_FILL, c1);
            Glcd_Box(midx-d, y1, midx+d, y2, c1);
            //setfillstyle(SOLID_FILL, c2);
            Glcd_Box(midx-d, y3, midx+d, y4, c2);
         default: break;
       }
}

void bar_plot(BAR *ptrbar, int y)
{
       int yold, midx, midy,d, col, c1, c2, y1, y2, y3, y4, ind;

       ptrbar->yold=ptrbar->y;
       ptrbar->y=y;

       yold=ptrbar->yold;
       //y=ptrbar->y;
       midx=ptrbar->midx;
       midy=ptrbar->midy;
       col=ptrbar->color;
       d=ptrbar->delta;
       if(yold>0 && y>0)
       {
          if(y>yold){
              y1=midy-y; y2=midy-yold-1;
              c1=col; ind=1;
          }
          else if(y<yold){
              y1=midy-yold; y2=midy-y-1;
              c1=BLACK; ind=1;
          }
          else{ ind=0; }
       }
       else if(yold<0 && y<0)
       {
          if(y>yold){
              y1=midy-y+1; y2=midy-yold;
              c1=BLACK; ind=1;
           }
          else if(y<yold){
              y1=midy-yold+1; y2=midy-y;
              c1=col; ind=1;
          }
          else{ ind=0; }
       }
       else if(yold<0 && y>0)
       {
           y1=midy+1; y2=midy-yold; c1=BLACK;
           y3=midy-y; y4=midy-1; c2=col;
           ind=2;
      }
       else if(yold>0 && y<0)
       {
           y1=midy-yold; y2= midy-1; c1=BLACK;
           y3=midy+1; y4=midy-y; c2=col;
           ind=2;
       }
       else if(yold==0){
           if(y>0){
               y1=midy-y; y2=midy-1;
               c1=col; ind=1;
           }
           else if(y<0){
              y1=midy+1; y2=midy-y;
              c1=col; ind=1;
           }
           else{ ind=0; }
       }
       else if(y==0){
           if(yold>0){
              y1=midy-yold; y2=midy-1;
              c1=BLACK; ind=1;
           }
           else if(yold<0){
               y1=midy+1; y2=midy-yold;
               c1=BLACK; ind=1;
           }
           else{ ind=0; }
       }
       else{ ind=0; }

       switch(ind){
          case 0: break;
          case 1:
             //setfillstyle(SOLID_FILL, c1);
             Glcd_Box(midx-d, y1, midx+d, y2, c1);
             break;
          case 2:
            //setfillstyle(SOLID_FILL, c1);
            Glcd_Box(midx-d, y1, midx+d, y2, c1);
            //setfillstyle(SOLID_FILL, c2);
            Glcd_Box(midx-d, y3, midx+d, y4, c2);
         default: break;
       }
}