#line 1 "f:/Stevan/KontrolGlcd/Glcd.c"
#line 1 "f:/stevan/kontrolglcd/pid.h"






typedef struct
{

  unsigned int  Kp, Ki, Kd;
} PID;

typedef struct process{
 float T,T1,a,b,K;
  int  y[10], u[10], e, eold;
 int N;

} PROCESS;

void process_set(PROCESS* p, float T,  int  N1, float T1, float K);
void pid_set(PID* pid, PROCESS* p, float Kp, float Ti, float Td);
 int  error(PROCESS* p,  int  x);
 int  pid(PROCESS* p, PID* pid);
 int  process(PROCESS* p);
void process_shift(PROCESS* p);
#line 1 "f:/stevan/kontrolglcd/bar.h"






typedef struct
{
 int yold,y, midx, midy, delta, color;

} BAR;

void bar_init(BAR *ptrbar, int yold, int y, int mx, int my, int c, int d);
void bar_set(BAR *ptrbar, int y);
void bar_plot1(BAR *ptrbar);
void bar_plot(BAR *ptrbar, int y);
#line 29 "f:/Stevan/KontrolGlcd/Glcd.c"
char GLCD_DataPort at PORTD;
sbit GLCD_CS1 at LATJ0_bit;
sbit GLCD_CS2 at LATJ1_bit;
sbit GLCD_RS at LATJ2_bit;
sbit GLCD_RW at LATJ3_bit;
sbit GLCD_EN at LATJ4_bit;
sbit GLCD_RST at LATJ5_bit;

sbit GLCD_CS1_Direction at TRISJ0_bit;
sbit GLCD_CS2_Direction at TRISJ1_bit;
sbit GLCD_RS_Direction at TRISJ2_bit;
sbit GLCD_RW_Direction at TRISJ3_bit;
sbit GLCD_EN_Direction at TRISJ4_bit;
sbit GLCD_RST_Direction at TRISJ5_bit;


PID pids[ 3 ];
PROCESS processes[ 3 ];
BAR xbars[ 3 ], ebars[ 3 ], ubars[ 3 ], ybars[ 3 ];

int i, k, ref, M=100;
int midy, d1;
char txts[ 3 ][5]={"PID1", "PID2","PID3"};
char text[6];

void delay2S(){
 Delay_ms(2000);
}

void bars_plot(void)
{
 int n;
 bar_plot(&xbars[i], ref);
 n=processes[i].N;
 bar_plot(&ubars[i], processes[i].u[n]/5);
 IntToStr(processes[i].u[n], text);
 Glcd_Write_Text(text, 40*i, 7, 0);
 bar_plot(&ybars[i], processes[i].y[n+1]);
 bar_plot(&ebars[i], processes[i].e);
}

void bars_processes_init(void)
{
 Glcd_Write_Text("x y e: 1,2,3", 0, 0, 2);
 Glcd_Write_Text("    u1", 0, 6, 1);
 Glcd_Write_Text("    u2", 40, 6, 1);
 Glcd_Write_Text("    u3", 80, 6, 1);

 d1=0;
 for(i=0; i< 3 ; i++)
 {
 bar_init(&xbars[i], 0, 0, 8*(4*i+1)+d1, midy,  1 , 3);
 bar_init(&ybars[i], 0, 0, 8*(4*i+2)+d1, midy,  1 , 3);
 bar_init(&ebars[i], 0, 0, 8*(4*i+3)+d1, midy,  1 , 3);
 bar_init(&ubars[i], 0, 0, 8*(4*i+4)+d1, midy,  1 , 3);
 d1+=8;

 process_set(&processes[i], 1, 2, 10, 0.7);
 pid_set(&pids[i], &processes[i], 3,2,3);
 }
}

void main() {
 ADCON1 |= 0x0F;
 CMCON |= 7;

 Glcd_Init();
 midy = 64 / 2;

 while(1) {
 Glcd_Fill(0x00);
 bars_processes_init();

 for(k=0; k<M; k++)
 {
 if(k<50) ref=18;
 else ref=8;

 for(i=0; i< 3 ;i++)
 {
 error(&processes[i], ref);
 pid(&processes[i], &pids[i]);
 process(&processes[i]);
 bars_plot();
 process_shift(&processes[i]);
 }
 Delay_ms(270);
 }
 Delay_ms(3000);
 }
}
