#line 1 "f:/Stevan/KontrolGlcd/PID.C"
#line 1 "f:/stevan/kontrolglcd/pid.h"






typedef struct
{

  unsigned int  Kp, Ki, Kd;
} PID;

typedef struct process{
 float T,T1,a,b,K;
  int  y[10], u[10], e, eold;
 int N;

} PROCESS;

void process_set(PROCESS* p, float T,  int  N1, float T1, float K);
void pid_set(PID* pid, PROCESS* p, float Kp, float Ti, float Td);
 int  error(PROCESS* p,  int  x);
 int  pid(PROCESS* p, PID* pid);
 int  process(PROCESS* p);
void process_shift(PROCESS* p);
#line 24 "f:/Stevan/KontrolGlcd/PID.C"
static  unsigned int  Kp, Ki, Kd, i;
static  long int  du, yk, yk_1, yk_2;

void process_set(PROCESS* p, float T,  int  N1, float T1, float K)
{
 p->e=0; p->eold=0;
 p->T=T;
 p->N=N1;
 p->T1=T1;
 p->K=K;
 p->a=exp(-(p->T)/(p->T1));
 p->b=(p->K)*(1-(p->a));
 for(i=0; i<=p->N; i++)
 {
 p->y[i]=p->u[i]=0;
 }
}

void pid_set(PID* pid, PROCESS* p, float Kp, float Ti, float Td)
{
 float T;
 T=p->T;

 pid->Kp=1024*Kp;
 pid->Ki=1024*Kp*T/Ti;
 pid->Kd=1024*Kp*Td/T;
}

 int  error(PROCESS* p,  int  x)
{
 int N;
 N=p->N;
 p->e=x-(p->y[N]);
 return p->e;
}

 int  pid(PROCESS* p, PID* pid)
{
 float T, e;
 int N;

 Kp= pid->Kp;
 Ki= pid->Ki;
 Kd= pid->Kd;

 T=p->T;
 N=p->N;
 e=p->e;
 yk=p->y[N]; yk_1=p->y[N-1]; yk_2=p->y[N-2];

 du=Kp*(yk_1-yk)+Ki*e-Kd*(yk-2*yk_1+yk_2);
 du>>=10;
 p->u[N]=(p->u[N-1])+du;
 return p->u[N];
}

 int  process(PROCESS* p)
{
 float a, b;
 int N;
 a=p->a;
 b=p->b;
 N=p->N;
 p->y[N+1]=a*(p->y[N])+b*(p->u[0]);
 return p->y[N+1];
}

void process_shift(PROCESS* p)
{
 int N;
 N=p->N;
 for(i=0; i<N; i++)
 {
 p->y[i]=p->y[i+1];
 p->u[i]=p->u[i+1];
 }
 p->y[i]=p->y[i+1];
 p->eold=p->e;
}
